"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

exports.__esModule = true;
exports.default = exports.StoreStateProvider = void 0;

var _react = _interopRequireWildcard(require("react"));

var _index = require("../../redux/index");

const StoreStateContext = (0, _react.createContext)((0, _index.getStore)().getState());

const StoreStateProvider = ({
  children
}) => {
  const _useState = (0, _react.useState)((0, _index.getStore)().getState()),
        state = _useState[0],
        setState = _useState[1];

  (0, _react.useEffect)(() => {
    const unsubscribe = (0, _index.onLogAction)(() => {
      setState((0, _index.getStore)().getState());
    });
    return unsubscribe;
  }, []);
  return _react.default.createElement(StoreStateContext.Provider, {
    value: state
  }, children);
};

exports.StoreStateProvider = StoreStateProvider;
var _default = StoreStateContext;
exports.default = _default;